import type { Disposer, PromiseMaybe, AbortSignal, OptionsHighlight, OptionsHighlighter, TextMateToken } from './types';
declare class TextMateHighlighter<Grammar extends string = string, Theme extends string = string> {
    private oniguruma;
    private registry;
    private tokenizer;
    constructor(options: OptionsHighlighter<Grammar, Theme>);
    highlightToAbstract: <T>(options: OptionsHighlight<Grammar, Theme>, highlighter: (tokens: TextMateToken[][], options: {
        backgroundColor?: string;
    }) => PromiseMaybe<T>) => Promise<T>;
    highlightToANSI: (options: OptionsHighlight<Grammar, Theme>) => Promise<string>;
    highlightToDOM: (options: OptionsHighlight<Grammar, Theme>) => Promise<HTMLPreElement>;
    highlightToHighlights: (options: OptionsHighlight<Grammar, Theme>) => Promise<[HTMLPreElement, Disposer]>;
    highlightToHTML: (options: OptionsHighlight<Grammar, Theme>) => Promise<string>;
    tokenize: (lines: string[], grammar: Grammar, theme: Theme, signal: AbortSignal | undefined, onTokens: (tokens: TextMateToken[], lineIndex: number) => void) => Promise<void>;
}
export default TextMateHighlighter;
export type { OptionsHighlight, OptionsHighlighter, TextMateToken };
